@extends('layouts.app')

@section('content')
<section class="page-header row">
	<h2> {{ $pageTitle }} <small> {{ $pageNote }} </small></h2>
	<ol class="breadcrumb">
		<li><a href="{{ url('') }}"> Dashboard </a></li>
		<li><a href="{{ url($pageModule) }}"> {{ $pageTitle }} </a></li>
		<li class="active"> Form  </li>		
	</ol>
</section>
<div class="page-content row">
	<div class="page-content-wrapper no-margin">

	{!! Form::open(array('url'=>'reuniones?return='.$return, 'class'=>'form-horizontal validated','files' => true )) !!}
	<div class="sbox">
		<div class="sbox-title clearfix">
			<div class="sbox-tools " >
				<a href="{{ url($pageModule.'?return='.$return) }}" class="tips btn btn-sm "  title="{{ __('core.btn_back') }}" ><i class="fa  fa-times"></i></a> 
			</div>
			<div class="sbox-tools pull-left" >
				<button name="apply" class="tips btn btn-sm btn-apply  "  title="{{ __('core.btn_back') }}" ><i class="fa  fa-check"></i> {{ __('core.sb_apply') }} </button>
				<button name="save" class="tips btn btn-sm btn-save"  title="{{ __('core.btn_back') }}" ><i class="fa  fa-paste"></i> {{ __('core.sb_save') }} </button> 
			</div>
		</div>	
		<div class="sbox-content clearfix">
	<ul class="parsley-error-list">
		@foreach($errors->all() as $error)
			<li>{{ $error }}</li>
		@endforeach
	</ul>		
<div class="col-md-12">
						<fieldset><legend> Control de Reuniones</legend>
				{!! Form::hidden('ReunionID', $row['ReunionID']) !!}					
									  <div class="form-group  " >
										<label for="Fecha" class=" control-label col-md-4 text-left"> Fecha <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  
				<div class="input-group m-b" style="width:150px !important;">
					{!! Form::text('Fecha', $row['Fecha'],array('class'=>'form-control input-sm date')) !!}
					<span class="input-group-addon"><i class="fa fa-calendar"></i></span>
				</div> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Descripcion" class=" control-label col-md-4 text-left"> Descripcion <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <input  type='text' name='Descripcion' id='Descripcion' value='{{ $row['Descripcion'] }}' 
						     class='form-control input-sm ' /> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Condominio" class=" control-label col-md-4 text-left"> Condominio <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <select name='Condominio' rows='5' id='Condominio' class='select2 '   ></select> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Temas" class=" control-label col-md-4 text-left"> Temas <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <textarea name='Temas' rows='5' id='Temas' class='form-control input-sm '  
				           >{{ $row['Temas'] }}</textarea> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Acuerdos" class=" control-label col-md-4 text-left"> Acuerdos <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <textarea name='Acuerdos' rows='5' id='Acuerdos' class='form-control input-sm '  
				           >{{ $row['Acuerdos'] }}</textarea> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Comentarios" class=" control-label col-md-4 text-left"> Comentarios <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <textarea name='Comentarios' rows='5' id='Comentarios' class='form-control input-sm '  
				           >{{ $row['Comentarios'] }}</textarea> 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> 					
									  <div class="form-group  " >
										<label for="Documentos" class=" control-label col-md-4 text-left"> Documentos <span class="asterix"> * </span></label>
										<div class="col-md-6">
										  <input  type='file' name='Documentos' id='Documentos' class='inputfile  @if($row['Documentos'] =='') class='required' @endif '  />

							<label for='Documentos'><i class='fa fa-upload'></i> Choose a file</label>
							<div class='Documentos_preview'></div>
					 	<div >
						{!! SiteHelpers::showUploadedFile($row['Documentos'],'/uploads/reuniones/') !!}
						
						</div>					
					 
										 </div> 
										 <div class="col-md-2">
										 	
										 </div>
									  </div> </fieldset>
			</div>
			
			

		</div>
	</div>
	<input type="hidden" name="action_task" value="save" />
	{!! Form::close() !!}
	</div>
</div>		
	
		 
   <script type="text/javascript">
	$(document).ready(function() { 
		
		
		
		$("#Condominio").jCombo("{!! url('reuniones/comboselect?filter=condominios:Nombre:Nombre') !!}",
		{  selected_value : '{{ $row["Condominio"] }}' });
		 		 

		$('.removeMultiFiles').on('click',function(){
			var removeUrl = '{{ url("reuniones/removefiles?file=")}}'+$(this).attr('url');
			$(this).parent().remove();
			$.get(removeUrl,function(response){});
			$(this).parent('div').empty();	
			return false;
		});		
		
	});
	</script>		 
@stop